import java.io.*;
import java.util.*;

/**
 * Klasse zum duplizieren von Leerzeilen in Textdateien
 */
public class DoubleSpace {
    public static void main(String[] args) throws FileNotFoundException {
        doubleSpace2("test.txt","out.txt");
    }

    /**
     * Duplizierzt Leerzeilen bzw Zeilenumbrueche der
     * Datei inputFileName und speichert das Ergebnis in
     * outputFileName ab
     */
    public static void doubleSpace(String inputFileName, String outputFileName) throws FileNotFoundException {
        Scanner input = new Scanner(new File(inputFileName));
        PrintStream output = new PrintStream(new File(outputFileName));

        if (input.hasNextLine()) {
            output.println(input.nextLine());
        }
        while (input.hasNextLine()) {
            output.println();
            output.println(input.nextLine());
        }

        output.close();
        input.close();
    }

    /**
     * Duplizierzt Leerzeilen bzw Zeilenumbrueche der
     * Datei inputFileName und speichert das Ergebnis in
     * outputFileName ab
     * Inklusive Fehlerbehandlung
     */
    public static void doubleSpace2(String inputFileName, String outputFileName) {

        Scanner input = null;
        PrintStream output = null;

        try {

            input = new Scanner(new File(inputFileName));
            output = new PrintStream(new File(outputFileName));

            if (input.hasNextLine()) {
                output.println(input.nextLine());
            }
            while (input.hasNextLine()) {
                output.println();
                output.println(input.nextLine());
            }

        } catch (FileNotFoundException e) {

            System.out.println(e.getMessage());

        } finally {

            if (output != null) output.close();
            if (input != null) input.close();

        }
    }
}
